/**
 * UGENE - Integrated Bioinformatics Tools.
 * Copyright (C) 2008-2013 UniPro <ugene@unipro.ru>
 * http://ugene.unipro.ru
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */

#include <U2Core/U2ObjectDbi.h>
#include <U2Core/U2OpStatusUtils.h>

#include <U2Lang/DbiDataStorage.h>

#include "DbiDataHandler.h"

namespace U2 {
namespace Workflow {

DbiDataHandler::DbiDataHandler(const U2DataId &id, U2ObjectDbi *dbi)
: id(id), dbi(dbi)
{

}

DbiDataHandler::~DbiDataHandler() {
    U2OpStatusImpl os;
    // TODO: removing is forbidden because of performance problems
    //dbi->removeObject(id, os);
    // TODO: how do you want to check @os???
}

DbiDataHandler::DbiDataHandler(const DbiDataHandler &) {
}

DbiDataHandler &DbiDataHandler::operator=(const DbiDataHandler &) {
    return *this;
}

bool DbiDataHandler::equals(const DbiDataHandler *other) const {
    if (NULL == other) {
        return false;
    }

    return (other->id == id) && (other->dbi == dbi);
}

int DbiDataHandler::getReferenceCount() const {
    return int(this->ref);
}

bool DbiDataHandler::isValid() const {
    return true;
}

}
}
